/**
 * An implementation of the Stochastic Simulation method of estimating Bayesian Network probabilities with/without evidence.
 * Algorithm from Section 4.4.3 of Pearl, Judea. "Probabilistic Reasoning in Intelligent Systems"
 * Creation date: (10/23/00 4:40:23 PM)
 * @author: Todd Neller
 */


class BNStochasticSimulation {
    /* iteration frequency of progress reports */
    static int reportFrequency = 1000;
    /* total iterations; each non-evidence variable is updated in each iteration */
    static int iterations = 10000;


/**
 * BNStochasticSimulation constructor.
 */
public BNStochasticSimulation() {
    super();
}


/**
 * Initialize parameters, parse input, display BN information, and perform stocahstic simulation.
 * @param args an array of command-line arguments
 */
public static void main(java.lang.String[] args) throws ParseException {
    // Initialize iterations and update frequency
    if (args.length > 0) {
        iterations = Integer.parseInt(args[0]);
        if (args.length > 1) {
            reportFrequency = Integer.parseInt(args[1]);
        }
    }
    
    // Read in belief net specification from System.in
    BNParse parser = new BNParse(System.in);
    parser.parseInput();
    BNNode.printBN();

    // Do stochastic simulation.
    simulate();
}


/**
 * Perform Stochastic Simulation as described in Section 4.4.3 of Pearl, Judea. "Probabilistic Reasoning in Intelligent Systems".
 * The enclosed file sample.out shows the output format given the input:
 *   java BNStochasticSimulation 10000000 2000000 < sample.in > sample.out
 * This is the only method you should modify.
 * Creation date: (10/23/00 5:32:39 PM)
 */
public static void simulate() {

    // ***INSERT YOUR CODE HERE***
    // My implementation was approx 80 lines.

}
}










